#pragma once
#include <string>
#include <initializer_list>
#include <map>
#include <any>
#include <vector>

struct phone {
	char name[128];
	char number[128];
	char date[128];
	double discount;				
	double percent_discount;		
	char time_start[128];
	char time_end[128];

	phone() = default;
	phone(const char*, const char*, const char*, double, double, const char*, const char*);

	friend std::istream& operator>>(std::istream& p_in, phone& p_prod);
	friend std::ostream& operator<<(std::ostream& p_out, const phone& p_prod);
};

class File
{
public:
	using map_array = std::map<int, phone>;

	File(const std::string&);

	void create_file();
	void add_to_file(const std::initializer_list<phone>&);
	void delete_from_file(int);
	void replace_in_file(int, const phone&);
	void transform_to_text();
	void search_by_date(const std::string&);
	void search_by_name(const std::string&);
	void search_by_number(const std::string&);
	
private:
	std::string m_fname;
	bool first_create = 0;
	map_array m_arr;

	void get_data();
};

